// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from marti_status_msgs:msg/ChronyTrackingStatus.idl
// generated code does not contain a copyright notice
#include "marti_status_msgs/msg/chrony_tracking_status__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `header`
#include "std_msgs/msg/header__functions.h"
// Member `reference`
// Member `leap_status`
#include "rosidl_generator_c/string_functions.h"

bool
marti_status_msgs__msg__ChronyTrackingStatus__init(marti_status_msgs__msg__ChronyTrackingStatus * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    marti_status_msgs__msg__ChronyTrackingStatus__fini(msg);
    return false;
  }
  // reference
  if (!rosidl_generator_c__String__init(&msg->reference)) {
    marti_status_msgs__msg__ChronyTrackingStatus__fini(msg);
    return false;
  }
  // stratum
  // system_time_offset
  // last_offset
  // rms_offset
  // frequency_offset
  // residual_frequency
  // skew
  // root_delay
  // root_dispersion
  // update_interval
  // leap_status
  if (!rosidl_generator_c__String__init(&msg->leap_status)) {
    marti_status_msgs__msg__ChronyTrackingStatus__fini(msg);
    return false;
  }
  return true;
}

void
marti_status_msgs__msg__ChronyTrackingStatus__fini(marti_status_msgs__msg__ChronyTrackingStatus * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // reference
  rosidl_generator_c__String__fini(&msg->reference);
  // stratum
  // system_time_offset
  // last_offset
  // rms_offset
  // frequency_offset
  // residual_frequency
  // skew
  // root_delay
  // root_dispersion
  // update_interval
  // leap_status
  rosidl_generator_c__String__fini(&msg->leap_status);
}

marti_status_msgs__msg__ChronyTrackingStatus *
marti_status_msgs__msg__ChronyTrackingStatus__create()
{
  marti_status_msgs__msg__ChronyTrackingStatus * msg = (marti_status_msgs__msg__ChronyTrackingStatus *)malloc(sizeof(marti_status_msgs__msg__ChronyTrackingStatus));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(marti_status_msgs__msg__ChronyTrackingStatus));
  bool success = marti_status_msgs__msg__ChronyTrackingStatus__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
marti_status_msgs__msg__ChronyTrackingStatus__destroy(marti_status_msgs__msg__ChronyTrackingStatus * msg)
{
  if (msg) {
    marti_status_msgs__msg__ChronyTrackingStatus__fini(msg);
  }
  free(msg);
}


bool
marti_status_msgs__msg__ChronyTrackingStatus__Sequence__init(marti_status_msgs__msg__ChronyTrackingStatus__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  marti_status_msgs__msg__ChronyTrackingStatus * data = NULL;
  if (size) {
    data = (marti_status_msgs__msg__ChronyTrackingStatus *)calloc(size, sizeof(marti_status_msgs__msg__ChronyTrackingStatus));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = marti_status_msgs__msg__ChronyTrackingStatus__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        marti_status_msgs__msg__ChronyTrackingStatus__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
marti_status_msgs__msg__ChronyTrackingStatus__Sequence__fini(marti_status_msgs__msg__ChronyTrackingStatus__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      marti_status_msgs__msg__ChronyTrackingStatus__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

marti_status_msgs__msg__ChronyTrackingStatus__Sequence *
marti_status_msgs__msg__ChronyTrackingStatus__Sequence__create(size_t size)
{
  marti_status_msgs__msg__ChronyTrackingStatus__Sequence * array = (marti_status_msgs__msg__ChronyTrackingStatus__Sequence *)malloc(sizeof(marti_status_msgs__msg__ChronyTrackingStatus__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = marti_status_msgs__msg__ChronyTrackingStatus__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
marti_status_msgs__msg__ChronyTrackingStatus__Sequence__destroy(marti_status_msgs__msg__ChronyTrackingStatus__Sequence * array)
{
  if (array) {
    marti_status_msgs__msg__ChronyTrackingStatus__Sequence__fini(array);
  }
  free(array);
}
